package org.xbib.interlibrary.http.server.search;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.HttpRequest;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;
import java.util.Objects;

public class SearchFormAction extends J2HtmlResourceHandler {

    public SearchFormAction() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new ActionResource(this, httpRouterContext);
    }

    protected static class ActionResource extends J2HtmlResource {

        protected ActionResource(HtmlTemplateResourceHandler templateResourceHandler,
                                 HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected String renderHtml(HttpRouterContext context) {
            HttpRequest request = Objects.requireNonNull(context.getAttributes().get(HttpRequest.class, "request"));
            SearchWebApplicationModule app = Objects.requireNonNull(context.getAttributes().get(SearchWebApplicationModule.class, "app"));
            String id = app.getFormId("searchform", request);
            if (id != null) {
                app.executeSearch("searchform", request.getContext());
                seeOther(contextPath(request, "form/" + id));
            } else {
                gone();
            }
            return ""; // no content
        }
    }
}
